/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package view;

import controlers.ControleApiario;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import javax.jws.Oneway;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import models.BancoConnection;


/**
 *
 * @author familia
 */
public class PastosJFrame extends javax.swing.JFrame {    
    /**
     * Creates new form pastos
     */
    public PastosJFrame() {
        initComponents();
        
        listPasto.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent event) {
                if (!event.getValueIsAdjusting()) {
                    JList source = (JList) event.getSource();
                    if (source.isSelectionEmpty()) {
                        detalhar_btn.setEnabled(false);
                        excluir_btn.setEnabled(false);
                        editar_btn.setEnabled(false);
                    } else {
                        detalhar_btn.setEnabled(true);
                        excluir_btn.setEnabled(true);
                        editar_btn.setEnabled(true);
                    }
                }
            }
        });
    }
    /*
    public String getNome(){
        String nome = listPasto.getSelectedValue();
        return nome;
    }*/
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        listPasto = new javax.swing.JList<>();
        adicionar_btn = new javax.swing.JButton();
        detalhar_btn = new javax.swing.JButton();
        excluir_btn = new javax.swing.JButton();
        editar_btn = new javax.swing.JButton();
        voltar_btn = new javax.swing.JButton();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        pgInicial_menu = new javax.swing.JMenuItem();
        sair_menu = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Lista de Pastos");
        setPreferredSize(new java.awt.Dimension(430, 340));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanel1.setMinimumSize(new java.awt.Dimension(800, 600));

        jLabel1.setText("Selecione um Pasto Apícola");

        jScrollPane1.setViewportView(listPasto);

        adicionar_btn.setText("ADICIONAR");
        adicionar_btn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                adicionar_btnActionPerformed(evt);
            }
        });

        detalhar_btn.setText("Detalhar");
        detalhar_btn.setEnabled(false);
        detalhar_btn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                detalhar_btnActionPerformed(evt);
            }
        });

        excluir_btn.setBackground(new java.awt.Color(255, 0, 0));
        excluir_btn.setForeground(new java.awt.Color(255, 255, 255));
        excluir_btn.setText("Excluir");
        excluir_btn.setEnabled(false);
        excluir_btn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                excluir_btnActionPerformed(evt);
            }
        });

        editar_btn.setBackground(new java.awt.Color(0, 204, 255));
        editar_btn.setForeground(new java.awt.Color(255, 255, 255));
        editar_btn.setText("Editar");
        editar_btn.setEnabled(false);
        editar_btn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editar_btnActionPerformed(evt);
            }
        });

        voltar_btn.setText("< Voltar");
        voltar_btn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                voltar_btnActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 240, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(26, 26, 26)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(voltar_btn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(excluir_btn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(editar_btn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(adicionar_btn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(detalhar_btn, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(276, 276, 276))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(jLabel1))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGap(57, 57, 57)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(adicionar_btn)
                                .addGap(18, 18, 18)
                                .addComponent(detalhar_btn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(editar_btn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(excluir_btn)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(voltar_btn))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jMenu1.setText("Navegar");

        pgInicial_menu.setText("Página Inicial");
        pgInicial_menu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pgInicial_menuActionPerformed(evt);
            }
        });
        jMenu1.add(pgInicial_menu);

        sair_menu.setText("Sair");
        sair_menu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sair_menuActionPerformed(evt);
            }
        });
        jMenu1.add(sair_menu);

        jMenuBar2.add(jMenu1);

        jMenu2.setText("Sobre");
        jMenu2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jMenu2MouseClicked(evt);
            }
        });
        jMenuBar2.add(jMenu2);

        setJMenuBar(jMenuBar2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 664, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 136, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 499, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 105, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents
    
    private void adicionar_btnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_adicionar_btnActionPerformed
        // TODO add your handling code here:
        new AdicionarPastoJFrame().setVisible(true);
        dispose();
    }//GEN-LAST:event_adicionar_btnActionPerformed
    
    private void pgInicial_menuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pgInicial_menuActionPerformed
        // TODO add your handling code here:
        new HomeJFrame().setVisible(true);
        dispose();        
    }//GEN-LAST:event_pgInicial_menuActionPerformed

    private void detalhar_btnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_detalhar_btnActionPerformed
        // TODO add your handling code here:     
        new ApiariosJFrame().setVisible(true);
        dispose();
    }//GEN-LAST:event_detalhar_btnActionPerformed

    private void voltar_btnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_voltar_btnActionPerformed
        // TODO add your handling code here:
        new HomeJFrame().setVisible(true);
        dispose();
    }//GEN-LAST:event_voltar_btnActionPerformed

    private void sair_menuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sair_menuActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_sair_menuActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        try {
            // TODO add your handling code here:
            listar();
        } catch (SQLException ex) {
            JOptionPane.showMessageDialog(null, "Erro");
        }
    }//GEN-LAST:event_formWindowOpened

    private void excluir_btnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_excluir_btnActionPerformed
        // TODO add your handling code here:
        String nome = listPasto.getSelectedValue();
        Connection conexao = BancoConnection.getConnection();
        try {
            Statement stmt = conexao.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT * FROM pasto WHERE nomePasto='"+nome+"';");
            Integer foreign = null;
            while(rs.next()){
                foreign = rs.getInt(1);
            }
            
            ControleApiario apiario = new ControleApiario();
            apiario.rmvApiarioAuto(foreign);
             
            
            String str = "DELETE FROM pasto WHERE nomePasto=?;";
            PreparedStatement ps = conexao.prepareStatement(str);
            ps.setString(1, nome);
            ps.executeUpdate();
            
            JOptionPane.showMessageDialog(null, nome+" foi excluido!");
            
            listar();
        } catch (SQLException ex) {
            JOptionPane.showMessageDialog(null, "Não foi possivel excluir o pasto "+nome+"!");
        }
    }//GEN-LAST:event_excluir_btnActionPerformed

    
    /*
    DESABILITAR OS BOTÕES QUANDO NENHUM PASTO ESTIVER SELECIONADO
    
     * if(listPasto.getSelectedIndex()<0){
            detalhar_btn.setEnabled(false);
            excluir_btn.setEnabled(false);
            editar_btn.setEnabled(false);
            
        }else{
            detalhar_btn.setEnabled(true);
            excluir_btn.setEnabled(true);
            editar_btn.setEnabled(true);
            
            System.out.println("não clicado");
        }
     */
    
    
    
    
    
    private void editar_btnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editar_btnActionPerformed
        // TODO add your handling code here:        
        new AdicionarPastoJFrame().setVisible(true);
        dispose();
    }//GEN-LAST:event_editar_btnActionPerformed

    private void jMenu2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenu2MouseClicked
        JOptionPane.showMessageDialog(null,"Criado por Lucas e Mesaque","Sobre", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_jMenu2MouseClicked
    public static void listar() throws SQLException{
        DefaultListModel model = new DefaultListModel();
        Connection conexao = BancoConnection.getConnection();
        Statement stmt = conexao.createStatement();
        
        ResultSet rs = stmt.executeQuery("SELECT nomePasto FROM pasto;" );
        while(rs.next()){
            model.addElement(rs.getString(1));
        }        
        listPasto.setModel(model);
    }
    
    public static String getNome(){
        String nome = listPasto.getSelectedValue();
        return nome;
    }
    /**
     * @param args the command line arguments
     */
    
     
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(PastosJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(PastosJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(PastosJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(PastosJFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new PastosJFrame().setVisible(true);
                
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton adicionar_btn;
    private javax.swing.JButton detalhar_btn;
    private javax.swing.JButton editar_btn;
    private javax.swing.JButton excluir_btn;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private static javax.swing.JList<String> listPasto;
    private javax.swing.JMenuItem pgInicial_menu;
    private javax.swing.JMenuItem sair_menu;
    private javax.swing.JButton voltar_btn;
    // End of variables declaration//GEN-END:variables
}
